*** Fotos_umbenennen Version 1.2 ***********************************
*** Umbenennen von Fotos in einer Attributspalte *******************
*** Der Pfad wird entfernt und durch die Vorgabe ersetzt ***********
*** Nationalparkamt Hunsrück-Hochwald, Rainer Maria Kreten, Mai 2018
*** Aenderung Feb. 2020 "/" wird in "\" umgesetzt ******************
********************************************************************
#include "minigui.ch"
Function Main
parameters mtabelle, mfeldname, mpraefixneu
if pcount() = 0
   pende("Aufruf : <DBF-Datei> <Feldname> <neuer Pfad> ")
endif
if pcount() = 2
   mpraefixneu = ""
endif
set century on
set date GERMAN
if upper(right(mtabelle,4)) <> ".DBF"  // wenn die Dateiendung fehlt, wird sie angehängt
   mtabelle = alltrim(mtabelle) + ".DBF"
endif
mfhnr = fopen(mtabelle,2) // Ist die Datei vorhanden und beschreibbar?
if mfhnr < 0
   pende("Die Datei " + mtabelle + " ist nicht vorhanden oder bereits geoeffnet.")
else
   fclose(mfhnr)
endif
if right(mpraefixneu,1) <> "\"  // wenn ein Backslash fehlt wird es angehaengt
   mpraefixneu = alltrim(mpraefixneu) + "\"
endif

use &mtabelle
If fieldpos(mfeldname) <1  // Gibt es das Feld mit den Dateinamen ueberhaupt?
   pende("Das Feld " + mfeldname + " existiert nicht.")
endif   
If fieldtype(fieldpos(mfeldname)) <> "C" // Ist es ein Textfeld?
   pende("Das Feld " + mfeldname + " ist kein Textfeld.")
endif   

go top
do while .not. eof()
   mdateiori = charrepl('/',alltrim(&mfeldname),'\')
   manzahl_Token = numtoken(mdateiori,"\")
   mdatei = token(mdateiori,"\",manzahl_token)
   if manzahl_Token > 0 // nur wenn das Feld einen sinnvollen Inhalt enthält ueberschreiben
      replace &mfeldname with mpraefixneu + mdatei
      ? mdateiori + " > "  + mpraefixneu + mdatei
      ?
   endif	  
   skip
enddo
commit
Pende()
quit

Procedure Pende()  // alles schoen aufraeumen!
parameters mgrund
set console on
?
if pcount() > 0
   ? mgrund
   millisec(5000)
   doserror(1)
else
   ? "OK, fertig!"
   doserror(0)
endif
?
?   
quit

   